;================================================================
; FILE:        factorial.asm
;
; DESCRIPTION: Computes the factorial of the 16-bit integer value
;              in register R[2]. Result is stored at address
;              _result in data memory. Default is to compute
;              the factorial of 1.
;================================================================

	; reserve memory for result
	.bss _result, 2
	
	; begin program code
	.text

	; R[2] is the paramter of the factorial function
	; default is to compute fac(5)
	LDL R[2], #5
	
	; prepare the address base register for branches
	LDL R[0], #(_loop >> 8)		

	; R[3]=1	
	LDL R[3], #1

	; if R[2]==0 goto end		
	BC @_end, R[2]:EQ	

	; R[1]=-1
	LDH R[1], #-1
	LDL R[1], #-1

_loop:  

	;*******************************
	; do { 

	       ; R[3]=R[3]*R[2]
	       MUL R[3], R[3], R[2]

	       ; R[2]=R[2]+R[1]
	       ADD R[2], R[2], R[1]

	; } while R[2]!=0
	;*******************************
	BC @_loop, R[2]:NEQ

_end:

	; prepare base address register for the result
	LDL R[0], #(_result >> 8)

	; Store R[3] at result
	STR R[3], @_result

	; Program ends here
      	NOP
      	NOP
      	NOP
      	NOP
      	NOP
	.end
